<!-- 退回 -->
<script lang="ts" setup name="teminateDialog">
import type { FormInstance, FormRules } from 'element-plus'
import { ElMessage, ElMessageBox } from 'element-plus'
import { reactive, ref } from 'vue'
import {
  backOrder,
} from '@/api/business/schedule/order'
// 对外暴露的方法： 退回成功
const emit = defineEmits(['backSuccess'])
// 弹窗显示状态
const dialogVisible = ref(false)
// 默认表单
const formData = ref({
  id: '', // 委托书id
  reason: '', // 终止原因
})

// 保存按钮加载状态
const btnLoading = ref(false)

// ---------------表单提交--------------------------------
// 表单对象
const dataFormRef = ref<FormInstance>()
// 校验规则
const rules = reactive<FormRules>({
  reason: [{ required: true, message: '退回原因必填', trigger: ['blur', 'change'] }],
})
/**
 * 初始化审批弹窗
 * @param id 委托书id
 */
function initDialog(row: { id: string }) {
  // dataFormRef.value!.clearValidate()
  formData.value.id = row.id
  dialogVisible.value = true
}
// 提交表单
function submitForm(formEl: FormInstance | undefined) {
  if (!formEl) { return }
  formEl.validate((valid) => {
    if (valid) {
      backOrder(formData.value).then((res) => {
        ElMessage.success('已退回')
        btnLoading.value = false
        dialogVisible.value = false
        emit('backSuccess')
      }).catch((_) => {
        btnLoading.value = false
      })
    }
  })
}
// 关闭弹窗
function handleClose() {
  dialogVisible.value = false
}

// ----------------------- 以下是暴露的方法内容 ----------------------------
defineExpose({ initDialog })
</script>

<template>
  <el-dialog
    v-model="dialogVisible"
    title="退回"
    width="600"
    :before-close="handleClose"
  >
    <el-form
      ref="dataFormRef"
      label-position="top"
      label-width="80px"
      :model="formData"
      :rules="rules"
    >
      <el-row :gutter="24">
        <el-col :span="24">
          <el-form-item label="请输入退回原因" prop="reason">
            <el-input
              v-model="formData.reason"
              :rows="4"
              show-word-limit
              type="textarea"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button type="primary" :loading="btnLoading" @click="submitForm(dataFormRef)">
        提交
      </el-button>
      <el-button type="info" @click="handleClose">
        取消
      </el-button>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
// 样式
</style>
